#include<bits/stdc++.h>
#define ll long long
#define ull unsigned long long
#define pb push_back
#define mk make_pair
#define v_sort(x) sort(x.begin(),x.end())
#define v_gsort(x) sort(x.begin(),x.end(),greater<int>())
#define v_find(x,num) find(x.begin(),x.end(),num)
#define PI 3.14159265
#define MOD 998244353
#define MOD1 1000000007

using namespace std;

ull gcd(ull a,ull b){
  if(a==0) return b;
  return gcd(b%a,a);
}

void Solve(){
  int n,m;
  cin>>n>>m;
  vector<ll>a(n),b(m),c(n-1);
  for(int i=0;i<n;i++) cin>>a[i];
  for(int i=0;i<m;i++) {
    cin>>b[i];
  }
  v_sort(a);
  for(int i=1;i<n;i++) c[i-1]=a[i]-a[i-1];
  ull g=c[0];
  for(int i=1;i<n-1;i++){
    g=gcd(c[i],g);
    if(g==1) {cout<<"0\n";return;}
  }
  set<ll>divs;
  for(ull i=1;i*i<=min(g,(ull)1e14);i++){
    if(g%i==0) {
      divs.insert(i);
      if(g/i!=i) divs.insert(g/i);
    }
  }
  bool ok=0;
  int i;
  for(auto &it:divs){
    for(i=0;i<m;i++){
      if(abs((b[i]-a[0]))%it==0) break;
    }
    if(i==m) {ok=1;break;}
  }
  cout<<(ok?"1\n":"0\n");
}

int main(){
  ios::sync_with_stdio(false);
  cin.tie(NULL);
  int t=1;
  cin>>t;
  while(t--){
    Solve();
  }
  return 0;
}